# keap-core-v2-sdk
Keap REST Core Service

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.70.0.809589
- Package version: 1.0.10
- Generator version: 7.13.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://developer.keap.com/get-support/](https://developer.keap.com/get-support/)

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/infusionsoft/keap-sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/infusionsoft/keap-sdk.git`)

Then import the package:
```python
import keap_core_v2_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import keap_core_v2_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import keap_core_v2_client
from keap_core_v2_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.keap.com/crm/rest
# See configuration.py for a list of all supported configuration parameters.
configuration = keap_core_v2_client.Configuration(
    host = "https://api.keap.com/crm/rest"
)


# Enter a context with an instance of the API client
with keap_core_v2_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = keap_core_v2_client.AffiliateApi(api_client)
    id = 'id_example' # str | id
    affiliate_add_to_program_request = keap_core_v2_client.AffiliateAddToProgramRequest() # AffiliateAddToProgramRequest | affiliateAddToProgramRequest

    try:
        # Assign Affiliate to Commission program
        api_instance.add_affiliate_to_program_using_post(id, affiliate_add_to_program_request)
    except ApiException as e:
        print("Exception when calling AffiliateApi->add_affiliate_to_program_using_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.keap.com/crm/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AffiliateApi* | [**add_affiliate_to_program_using_post**](docs/AffiliateApi.md#add_affiliate_to_program_using_post) | **POST** /v2/affiliates/{id}:assignToProgram | Assign Affiliate to Commission program
*AffiliateApi* | [**add_affiliate_using_post**](docs/AffiliateApi.md#add_affiliate_using_post) | **POST** /v2/affiliates | Create an Affiliate
*AffiliateApi* | [**add_commission_program_using_post**](docs/AffiliateApi.md#add_commission_program_using_post) | **POST** /v2/affiliates/commissionPrograms | Create an Affiliate Commission Program
*AffiliateApi* | [**assign_product_commission_program_using_post**](docs/AffiliateApi.md#assign_product_commission_program_using_post) | **POST** /v2/affiliates/commissionPrograms/productCommissionProgram/{commission_program_id} | Assign a Product Commission Program
*AffiliateApi* | [**assign_subscription_commission_program_using_post**](docs/AffiliateApi.md#assign_subscription_commission_program_using_post) | **POST** /v2/affiliates/commissionPrograms/subscriptionCommissionProgram/{commission_program_id} | Assign a Subscription Commission Program
*AffiliateApi* | [**create_default_commission_program_using_post**](docs/AffiliateApi.md#create_default_commission_program_using_post) | **POST** /v2/affiliates/commissionPrograms/defaultCommissionProgram/{commission_program_id} | Create a Default Commission Program
*AffiliateApi* | [**create_redirect_link_using_post**](docs/AffiliateApi.md#create_redirect_link_using_post) | **POST** /v2/affiliates/redirects | Create an Affiliate Link
*AffiliateApi* | [**delete_affiliate_commission_program_using_delete**](docs/AffiliateApi.md#delete_affiliate_commission_program_using_delete) | **DELETE** /v2/affiliates/commissionPrograms/{commission_program_id} | Delete a Commission Program
*AffiliateApi* | [**delete_affiliate_using_delete**](docs/AffiliateApi.md#delete_affiliate_using_delete) | **DELETE** /v2/affiliates/{id} | Delete Affiliate
*AffiliateApi* | [**delete_redirect_link_using_delete**](docs/AffiliateApi.md#delete_redirect_link_using_delete) | **DELETE** /v2/affiliates/redirects/{redirect_id} | Delete an Affiliate Link
*AffiliateApi* | [**get_affiliate_commission_total_using_get**](docs/AffiliateApi.md#get_affiliate_commission_total_using_get) | **GET** /v2/affiliates/{affiliate_id}/commissionTotal | Retrieve Affiliate Commission Earned and View LedgerURl for portal
*AffiliateApi* | [**get_affiliate_commissions_using_get**](docs/AffiliateApi.md#get_affiliate_commissions_using_get) | **GET** /v2/affiliates/{affiliate_id}:commissions | Retrieve Affiliate Commission and Clawbacks
*AffiliateApi* | [**get_affiliate_using_get1**](docs/AffiliateApi.md#get_affiliate_using_get1) | **GET** /v2/affiliates/{id} | Retrieve an Affiliate
*AffiliateApi* | [**get_commission_program_using_get**](docs/AffiliateApi.md#get_commission_program_using_get) | **GET** /v2/affiliates/commissionPrograms/{commission_program_id} | Retrieve a Commission Program
*AffiliateApi* | [**get_redirect_link_using_get**](docs/AffiliateApi.md#get_redirect_link_using_get) | **GET** /v2/affiliates/redirects/{redirect_id} | Retrieve an Affiliate Link
*AffiliateApi* | [**list_affiliate_commission_programs_using_get**](docs/AffiliateApi.md#list_affiliate_commission_programs_using_get) | **GET** /v2/affiliates/commissionPrograms | List Affiliate Commission Programs
*AffiliateApi* | [**list_affiliate_links_using_get**](docs/AffiliateApi.md#list_affiliate_links_using_get) | **GET** /v2/affiliates/redirects | List Affiliate Links
*AffiliateApi* | [**list_summaries_using_get1**](docs/AffiliateApi.md#list_summaries_using_get1) | **GET** /v2/affiliates/summaries | List Affiliate Summaries
*AffiliateApi* | [**remove_affiliate_from_program_using_post**](docs/AffiliateApi.md#remove_affiliate_from_program_using_post) | **POST** /v2/affiliates/{id}:removeFromProgram | Remove an Affiliate from a Commission Program
*AffiliateApi* | [**remove_product_commission_from_commissions_using_post**](docs/AffiliateApi.md#remove_product_commission_from_commissions_using_post) | **POST** /v2/affiliates/commissionPrograms/{commission_id}:removeProductCommission | Remove a Product from a Commission Program
*AffiliateApi* | [**remove_subscription_plan_commission_from_commissions_using_post**](docs/AffiliateApi.md#remove_subscription_plan_commission_from_commissions_using_post) | **POST** /v2/affiliates/commissionPrograms/{commission_id}:removeSubscriptionCommission | Remove a Subscription from a Commission Program
*AffiliateApi* | [**update_affiliate_using_patch**](docs/AffiliateApi.md#update_affiliate_using_patch) | **PATCH** /v2/affiliates/{id} | Update an Affiliate
*AffiliateApi* | [**update_commission_program_using_patch**](docs/AffiliateApi.md#update_commission_program_using_patch) | **PATCH** /v2/affiliates/commissionPrograms/{commission_program_id} | Update an Affiliate Commission Program
*AffiliateApi* | [**update_default_commission_program_using_patch**](docs/AffiliateApi.md#update_default_commission_program_using_patch) | **PATCH** /v2/affiliates/commissionPrograms/defaultCommissionPrograms/{commission_program_id} | Update a Default Commission Program
*AffiliateApi* | [**update_product_commission_program_using_patch**](docs/AffiliateApi.md#update_product_commission_program_using_patch) | **PATCH** /v2/affiliates/commissionPrograms/productCommissionPrograms/{commission_program_id} | Update a Product Commission Program
*AffiliateApi* | [**update_redirect_link_using_patch**](docs/AffiliateApi.md#update_redirect_link_using_patch) | **PATCH** /v2/affiliates/redirects/{redirect_id} | Update an Affiliate Link
*AffiliateApi* | [**update_subscription_commission_program_using_patch**](docs/AffiliateApi.md#update_subscription_commission_program_using_patch) | **PATCH** /v2/affiliates/commissionPrograms/subscriptionCommissionPrograms/{commission_program_id} | Update a Subscription Commission Program
*AutomationApi* | [**add_contacts_to_automation_sequence_using_post**](docs/AutomationApi.md#add_contacts_to_automation_sequence_using_post) | **POST** /v2/automations/{automation_id}/sequences/{sequence_id}:addContacts | Add Contacts to an Automation Sequence
*AutomationApi* | [**bulk_assignment_automations_categories_using_post**](docs/AutomationApi.md#bulk_assignment_automations_categories_using_post) | **POST** /v2/automations/categories/batchAssign | Bulk update for Automations Categories
*AutomationApi* | [**delete_automation_using_delete**](docs/AutomationApi.md#delete_automation_using_delete) | **DELETE** /v2/automations | Delete an Automation
*AutomationApi* | [**get_automation_using_get**](docs/AutomationApi.md#get_automation_using_get) | **GET** /v2/automations/{automation_id} | Retrieve an Automation
*AutomationApi* | [**list_all_automation_ids_using_get**](docs/AutomationApi.md#list_all_automation_ids_using_get) | **GET** /v2/automations/ids | List Automations Ids
*AutomationApi* | [**list_automations_using_get**](docs/AutomationApi.md#list_automations_using_get) | **GET** /v2/automations | List Automations
*AutomationApi* | [**update_automation_category_using_put**](docs/AutomationApi.md#update_automation_category_using_put) | **PUT** /v2/automations/category | Update an Automation&#39;s Category
*AutomationCategoryApi* | [**create_category_using_post**](docs/AutomationCategoryApi.md#create_category_using_post) | **POST** /v2/automationCategory | Create automation category
*AutomationCategoryApi* | [**delete_categories_using_delete**](docs/AutomationCategoryApi.md#delete_categories_using_delete) | **DELETE** /v2/automationCategory | Delete automation category
*AutomationCategoryApi* | [**list_categories_using_get**](docs/AutomationCategoryApi.md#list_categories_using_get) | **GET** /v2/automationCategory | List automation categories
*AutomationCategoryApi* | [**patch_category_using_patch**](docs/AutomationCategoryApi.md#patch_category_using_patch) | **PATCH** /v2/automationCategory/{id} | Update automation category
*AutomationCategoryApi* | [**save_category_using_put**](docs/AutomationCategoryApi.md#save_category_using_put) | **PUT** /v2/automationCategory | Save automation category
*BusinessProfileApi* | [**get_business_profile_using_get**](docs/BusinessProfileApi.md#get_business_profile_using_get) | **GET** /v2/businessProfile | Retrieve Business Profile
*BusinessProfileApi* | [**update_business_profile_using_patch**](docs/BusinessProfileApi.md#update_business_profile_using_patch) | **PATCH** /v2/businessProfile | Update Business Profile
*CampaignApi* | [**add_contacts_to_campaign_sequence_using_post1**](docs/CampaignApi.md#add_contacts_to_campaign_sequence_using_post1) | **POST** /v2/campaigns/{campaign_id}/sequences/{sequence_id}:addContacts | Add Contacts to Campaign Sequence
*CampaignApi* | [**get_campaign_using_get1**](docs/CampaignApi.md#get_campaign_using_get1) | **GET** /v2/campaigns/{campaign_id} | Retrieve a Campaign
*CampaignApi* | [**list_campaigns_using_get1**](docs/CampaignApi.md#list_campaigns_using_get1) | **GET** /v2/campaigns | List Campaigns
*CampaignApi* | [**remove_contacts_from_campaign_sequence_using_post**](docs/CampaignApi.md#remove_contacts_from_campaign_sequence_using_post) | **POST** /v2/campaigns/{campaign_id}/sequences/{sequence_id}:removeContacts | Remove Contacts from Campaign Sequence
*CompanyApi* | [**create_company_using_post1**](docs/CompanyApi.md#create_company_using_post1) | **POST** /v2/companies | Create a Company
*CompanyApi* | [**delete_company_using_delete**](docs/CompanyApi.md#delete_company_using_delete) | **DELETE** /v2/companies/{company_id} | Delete a Company
*CompanyApi* | [**get_company_using_get1**](docs/CompanyApi.md#get_company_using_get1) | **GET** /v2/companies/{company_id} | Retrieve a Company
*CompanyApi* | [**list_companies_using_get1**](docs/CompanyApi.md#list_companies_using_get1) | **GET** /v2/companies | List Companies
*CompanyApi* | [**update_company_using_patch1**](docs/CompanyApi.md#update_company_using_patch1) | **PATCH** /v2/companies/{company_id} | Update a Company
*ContactApi* | [**create_contact_link_type_using_post**](docs/ContactApi.md#create_contact_link_type_using_post) | **POST** /v2/contacts/links/types | Create a Contact Link type
*ContactApi* | [**create_contact_using_post1**](docs/ContactApi.md#create_contact_using_post1) | **POST** /v2/contacts | Create a Contact
*ContactApi* | [**delete_contact_using_delete1**](docs/ContactApi.md#delete_contact_using_delete1) | **DELETE** /v2/contacts/{contact_id} | Delete a Contact
*ContactApi* | [**get_contact_using_get1**](docs/ContactApi.md#get_contact_using_get1) | **GET** /v2/contacts/{contact_id} | Retrieve a Contact
*ContactApi* | [**link_contacts_using_post**](docs/ContactApi.md#link_contacts_using_post) | **POST** /v2/contacts:link | Link Contacts
*ContactApi* | [**list_contact_link_types_using_get**](docs/ContactApi.md#list_contact_link_types_using_get) | **GET** /v2/contacts/links/types | List Contact Link types
*ContactApi* | [**list_contact_links_using_get**](docs/ContactApi.md#list_contact_links_using_get) | **GET** /v2/contacts/{contact_id}/links | List Linked Contacts
*ContactApi* | [**list_contacts_using_get1**](docs/ContactApi.md#list_contacts_using_get1) | **GET** /v2/contacts | List Contacts
*ContactApi* | [**retrieve_contact_model_using_get1**](docs/ContactApi.md#retrieve_contact_model_using_get1) | **GET** /v2/contacts/model | Retrieve Contact Model
*ContactApi* | [**unlink_contacts_using_post**](docs/ContactApi.md#unlink_contacts_using_post) | **POST** /v2/contacts:unlink | Delete Link between two Contacts
*ContactApi* | [**update_contact_using_patch**](docs/ContactApi.md#update_contact_using_patch) | **PATCH** /v2/contacts/{contact_id} | Update a Contact
*CustomFieldsApi* | [**get_custom_fields**](docs/CustomFieldsApi.md#get_custom_fields) | **GET** /v2/customFields | Retrieves a list of custom fields in a tenant.
*CustomFieldsApi* | [**update_custom_field**](docs/CustomFieldsApi.md#update_custom_field) | **PATCH** /v2/customFields/{custom_field_id} | Updates a custom field
*DateExpressionApi* | [**query_date_expressions**](docs/DateExpressionApi.md#query_date_expressions) | **GET** /v2/dateExpressions | 
*DealsApi* | [**create_deal**](docs/DealsApi.md#create_deal) | **POST** /v2/deals | Creates a new deal.
*DealsApi* | [**create_note**](docs/DealsApi.md#create_note) | **POST** /v2/deals/{id}/notes | Creates a new note for a specific deal.
*DealsApi* | [**create_notes_bulk**](docs/DealsApi.md#create_notes_bulk) | **POST** /v2/deals/-/notes | Creates new notes in bulk.
*DealsApi* | [**delete_deal**](docs/DealsApi.md#delete_deal) | **DELETE** /v2/deals/{id} | Deletes a specific deal by its ID.
*DealsApi* | [**delete_note**](docs/DealsApi.md#delete_note) | **DELETE** /v2/deals/-/notes/{note_id} | Deletes a specific deal note by its ID.
*DealsApi* | [**get_deal**](docs/DealsApi.md#get_deal) | **GET** /v2/deals/{deal_id} | Retrieves a specific deal by its ID.
*DealsApi* | [**get_note**](docs/DealsApi.md#get_note) | **GET** /v2/deals/-/notes/{note_id} | Retrieves a specific deal note by its ID.
*DealsApi* | [**list_deals**](docs/DealsApi.md#list_deals) | **GET** /v2/deals/-/contacts/{contact_id} | Lists all deals associated with a specific contact.
*DealsApi* | [**list_notes**](docs/DealsApi.md#list_notes) | **GET** /v2/deals/{id}/notes | Lists all notes associated with a specific deal.
*DealsApi* | [**update_note**](docs/DealsApi.md#update_note) | **PATCH** /v2/deals/-/notes/{note_id} | Updates a specific deal note by its ID.
*DisplayFormsApi* | [**get_display_form**](docs/DisplayFormsApi.md#get_display_form) | **GET** /v2/pipelines/{pipeline_id}/form | Retrieves a specific display form by a pipeline ID.
*DisplayFormsApi* | [**update_display_form**](docs/DisplayFormsApi.md#update_display_form) | **PATCH** /v2/pipelines/{pipeline_id}/form | Updates a display form
*EmailApi* | [**create_email_using_post1**](docs/EmailApi.md#create_email_using_post1) | **POST** /v2/emails | Create an Email Record
*EmailApi* | [**create_emails_using_post1**](docs/EmailApi.md#create_emails_using_post1) | **POST** /v2/emails:batchAdd | Create a set of Email Records
*EmailApi* | [**delete_email_using_delete1**](docs/EmailApi.md#delete_email_using_delete1) | **DELETE** /v2/emails/{id} | Delete an Email Record
*EmailApi* | [**delete_emails_using_post1**](docs/EmailApi.md#delete_emails_using_post1) | **POST** /v2/emails:batchRemove | Remove a set of Email Records
*EmailApi* | [**get_email_template_using_get**](docs/EmailApi.md#get_email_template_using_get) | **GET** /v2/emails/templates/{email_template_id} | Retrieve an email template
*EmailApi* | [**get_email_using_get1**](docs/EmailApi.md#get_email_using_get1) | **GET** /v2/emails/{id} | Retrieve an Email
*EmailApi* | [**send_email_template_using_post**](docs/EmailApi.md#send_email_template_using_post) | **POST** /v2/emails/templates:send | Send an email based on a template
*EmailApi* | [**send_email_using_post1**](docs/EmailApi.md#send_email_using_post1) | **POST** /v2/emails:send | Send an Email
*FilesApi* | [**create_file_using_post1**](docs/FilesApi.md#create_file_using_post1) | **POST** /v2/files | Create a file
*FilesApi* | [**delete_file_using_delete1**](docs/FilesApi.md#delete_file_using_delete1) | **DELETE** /v2/files/{file_id} | Delete a file
*FilesApi* | [**get_file_data_using_get**](docs/FilesApi.md#get_file_data_using_get) | **GET** /v2/files/{file_id}:data | Retrieve a file&#39;s data
*FilesApi* | [**get_file_using_get1**](docs/FilesApi.md#get_file_using_get1) | **GET** /v2/files/{file_id} | Retrieve a file
*FilesApi* | [**list_files_using_get1**](docs/FilesApi.md#list_files_using_get1) | **GET** /v2/files | List all files
*FilesApi* | [**update_file_using_post**](docs/FilesApi.md#update_file_using_post) | **POST** /v2/files/{file_id} | Update a file
*LeadSourceCategoriesApi* | [**create_lead_source_category_using_post**](docs/LeadSourceCategoriesApi.md#create_lead_source_category_using_post) | **POST** /v2/leadSourceCategories | Create a Lead Source Category
*LeadSourceCategoriesApi* | [**delete_lead_source_category_using_delete**](docs/LeadSourceCategoriesApi.md#delete_lead_source_category_using_delete) | **DELETE** /v2/leadSourceCategories/{lead_source_category_id} | Delete a Lead Source Category
*LeadSourceCategoriesApi* | [**get_lead_source_category_using_get**](docs/LeadSourceCategoriesApi.md#get_lead_source_category_using_get) | **GET** /v2/leadSourceCategories/{lead_source_category_id} | Retrieve a Lead Source Category
*LeadSourceCategoriesApi* | [**list_categories_using_get1**](docs/LeadSourceCategoriesApi.md#list_categories_using_get1) | **GET** /v2/leadSourceCategories | List Lead Source Categories
*LeadSourceCategoriesApi* | [**update_lead_source_category_using_patch**](docs/LeadSourceCategoriesApi.md#update_lead_source_category_using_patch) | **PATCH** /v2/leadSourceCategories/{lead_source_category_id} | Update a Lead Source Category
*LeadSourceExpensesApi* | [**create_lead_source_expense_using_post**](docs/LeadSourceExpensesApi.md#create_lead_source_expense_using_post) | **POST** /v2/leadSources/{lead_source_id}/expenses | Create a Lead Source Expense
*LeadSourceExpensesApi* | [**delete_lead_source_using_delete1**](docs/LeadSourceExpensesApi.md#delete_lead_source_using_delete1) | **DELETE** /v2/leadSources/{lead_source_id}/expenses/{lead_source_expense_id} | Delete a lead source expense
*LeadSourceExpensesApi* | [**get_lead_source_expense_using_get**](docs/LeadSourceExpensesApi.md#get_lead_source_expense_using_get) | **GET** /v2/leadSources/{lead_source_id}/expenses/{lead_source_expense_id} | Retrieve a Lead Source Expense
*LeadSourceExpensesApi* | [**list_lead_source_expenses_using_get**](docs/LeadSourceExpensesApi.md#list_lead_source_expenses_using_get) | **GET** /v2/leadSources/{lead_source_id}/expenses | List Lead Source Expenses
*LeadSourceExpensesApi* | [**update_lead_source_expense_using_patch**](docs/LeadSourceExpensesApi.md#update_lead_source_expense_using_patch) | **PATCH** /v2/leadSources/{lead_source_id}/expenses/{lead_source_expense_id} | Update a Lead Source Expense
*LeadSourceRecurringExpensesApi* | [**create_lead_source_recurring_expense_using_post**](docs/LeadSourceRecurringExpensesApi.md#create_lead_source_recurring_expense_using_post) | **POST** /v2/leadSources/{lead_source_id}/recurringExpenses | Create a Lead Source Recurring Expense
*LeadSourceRecurringExpensesApi* | [**delete_lead_source_recurring_expense_using_delete**](docs/LeadSourceRecurringExpensesApi.md#delete_lead_source_recurring_expense_using_delete) | **DELETE** /v2/leadSources/{lead_source_id}/recurringExpenses/{lead_source_recurring_expense_id} | Delete a Lead Source Recurring Expense
*LeadSourceRecurringExpensesApi* | [**get_lead_source_recurring_expense_using_get**](docs/LeadSourceRecurringExpensesApi.md#get_lead_source_recurring_expense_using_get) | **GET** /v2/leadSources/{lead_source_id}/recurringExpenses/{lead_source_recurring_expense_id} | Retrieve a Lead Source Recurring Expense
*LeadSourceRecurringExpensesApi* | [**list_expenses_incurred_from_lead_source_recurring_expense_using_get**](docs/LeadSourceRecurringExpensesApi.md#list_expenses_incurred_from_lead_source_recurring_expense_using_get) | **GET** /v2/leadSources/{lead_source_id}/recurringExpenses/{lead_source_recurring_expense_id}/expenses | Retrieves a list of expenses incurred from a recurring expense
*LeadSourceRecurringExpensesApi* | [**list_lead_source_recurring_expenses_using_get**](docs/LeadSourceRecurringExpensesApi.md#list_lead_source_recurring_expenses_using_get) | **GET** /v2/leadSources/{lead_source_id}/recurringExpenses | Retrieves a list of lead source recurring expenses
*LeadSourceRecurringExpensesApi* | [**update_lead_source_recurring_expense_using_patch**](docs/LeadSourceRecurringExpensesApi.md#update_lead_source_recurring_expense_using_patch) | **PATCH** /v2/leadSources/{lead_source_id}/recurringExpenses/{lead_source_recurring_expense_id} | Update a Lead Source Recurring Expense
*LeadSourcesApi* | [**create_lead_source_using_post**](docs/LeadSourcesApi.md#create_lead_source_using_post) | **POST** /v2/leadSources | Create a Lead Source
*LeadSourcesApi* | [**delete_lead_source_using_delete**](docs/LeadSourcesApi.md#delete_lead_source_using_delete) | **DELETE** /v2/leadSources/{lead_source_id} | Delete a Lead Source
*LeadSourcesApi* | [**get_lead_source_using_get**](docs/LeadSourcesApi.md#get_lead_source_using_get) | **GET** /v2/leadSources/{lead_source_id} | Retrieve a Lead Source
*LeadSourcesApi* | [**list_lead_sources_using_get**](docs/LeadSourcesApi.md#list_lead_sources_using_get) | **GET** /v2/leadSources | List Lead Sources
*LeadSourcesApi* | [**update_lead_source_using_patch**](docs/LeadSourcesApi.md#update_lead_source_using_patch) | **PATCH** /v2/leadSources/{lead_source_id} | Update a Lead Source
*NoteApi* | [**create_note_custom_field_using_post1**](docs/NoteApi.md#create_note_custom_field_using_post1) | **POST** /v2/notes/model/customFields | Create a Custom Field
*NoteApi* | [**create_note_using_post1**](docs/NoteApi.md#create_note_using_post1) | **POST** /v2/contacts/{contact_id}/notes | Create a Note
*NoteApi* | [**delete_note_using_delete1**](docs/NoteApi.md#delete_note_using_delete1) | **DELETE** /v2/contacts/{contact_id}/notes/{note_id} | Delete a Note
*NoteApi* | [**get_note_using_get1**](docs/NoteApi.md#get_note_using_get1) | **GET** /v2/contacts/{contact_id}/notes/{note_id} | Retrieve a Note
*NoteApi* | [**list_note_templates_using_get**](docs/NoteApi.md#list_note_templates_using_get) | **GET** /v2/notes/templates | Retrieve Note Templates
*NoteApi* | [**list_notes_using_get1**](docs/NoteApi.md#list_notes_using_get1) | **GET** /v2/contacts/{contact_id}/notes | List Notes
*NoteApi* | [**retrieve_note_model_using_get1**](docs/NoteApi.md#retrieve_note_model_using_get1) | **GET** /v2/notes/model | Retrieve Note Model
*NoteApi* | [**update_note_using_patch**](docs/NoteApi.md#update_note_using_patch) | **PATCH** /v2/contacts/{contact_id}/notes/{note_id} | Update a Note
*NoteApi* | [**update_notes_custom_field_using_patch**](docs/NoteApi.md#update_notes_custom_field_using_patch) | **PATCH** /v2/notes/model/customFields/{custom_field_id} | Update a Custom Field
*OpportunityApi* | [**create_opportunity_custom_fields_using_post**](docs/OpportunityApi.md#create_opportunity_custom_fields_using_post) | **POST** /v2/opportunities/model/customFields | Create an Opportunity Custom Field
*OpportunityApi* | [**create_opportunity_stage_using_post**](docs/OpportunityApi.md#create_opportunity_stage_using_post) | **POST** /v2/opportunities/stages | Create an Opportunity Stage
*OpportunityApi* | [**create_opportunity_using_post1**](docs/OpportunityApi.md#create_opportunity_using_post1) | **POST** /v2/opportunities | Create an Opportunity
*OpportunityApi* | [**delete_opportunity_stage_using_delete**](docs/OpportunityApi.md#delete_opportunity_stage_using_delete) | **DELETE** /v2/opportunities/stages/{stage_id} | Delete an Opportunity Stage
*OpportunityApi* | [**delete_opportunity_using_delete**](docs/OpportunityApi.md#delete_opportunity_using_delete) | **DELETE** /v2/opportunities/{opportunity_id} | Delete an Opportunity
*OpportunityApi* | [**get_opportunity_stage_using_get**](docs/OpportunityApi.md#get_opportunity_stage_using_get) | **GET** /v2/opportunities/stages/{stage_id} | Retrieve an Opportunity Stage
*OpportunityApi* | [**get_opportunity_using_get1**](docs/OpportunityApi.md#get_opportunity_using_get1) | **GET** /v2/opportunities/{opportunity_id} | Retrieve a Opportunity
*OpportunityApi* | [**list_opportunities_using_get1**](docs/OpportunityApi.md#list_opportunities_using_get1) | **GET** /v2/opportunities | List Opportunities
*OpportunityApi* | [**list_opportunity_stages_using_get**](docs/OpportunityApi.md#list_opportunity_stages_using_get) | **GET** /v2/opportunities/stages | List of Opportunity Stages
*OpportunityApi* | [**update_opportunity_custom_field_using_patch**](docs/OpportunityApi.md#update_opportunity_custom_field_using_patch) | **PATCH** /v2/opportunities/model/customFields/{custom_field_id} | Update a Opportunity&#39;s Custom Field
*OpportunityApi* | [**update_opportunity_stage_using_patch**](docs/OpportunityApi.md#update_opportunity_stage_using_patch) | **PATCH** /v2/opportunities/stages/{stage_id} | Update an Opportunity Stage
*OpportunityApi* | [**update_opportunity_using_patch**](docs/OpportunityApi.md#update_opportunity_using_patch) | **PATCH** /v2/opportunities/{opportunity_id} | Update an opportunity
*OrdersApi* | [**create_order_custom_field_using_post**](docs/OrdersApi.md#create_order_custom_field_using_post) | **POST** /v2/orders/model/customFields | Create an Order Custom Field
*OrdersApi* | [**delete_order_custom_field_using_delete**](docs/OrdersApi.md#delete_order_custom_field_using_delete) | **DELETE** /v2/orders/model/customFields/{custom_field_id} | Delete an Order Custom Field
*OrdersApi* | [**retrieve_order_custom_field_model_using_get**](docs/OrdersApi.md#retrieve_order_custom_field_model_using_get) | **GET** /v2/orders/model | Retrieve Order Custom Field Model
*OrdersApi* | [**update_order_custom_field_using_patch**](docs/OrdersApi.md#update_order_custom_field_using_patch) | **PATCH** /v2/orders/model/customFields/{custom_field_id} | Update an Order Custom Field
*PaymentMethodConfigsApi* | [**create_payment_method_config_using_post**](docs/PaymentMethodConfigsApi.md#create_payment_method_config_using_post) | **POST** /v2/paymentMethodConfigs | Create Payment Method Configuration
*PipelinesApi* | [**create**](docs/PipelinesApi.md#create) | **POST** /v2/pipelines | Creates a new entity.
*PipelinesApi* | [**delete**](docs/PipelinesApi.md#delete) | **DELETE** /v2/pipelines/{id} | Deletes a pipeline.
*PipelinesApi* | [**get**](docs/PipelinesApi.md#get) | **GET** /v2/pipelines/{id} | Retrieves an entity by its identifier.
*PipelinesApi* | [**get_deal_count**](docs/PipelinesApi.md#get_deal_count) | **GET** /v2/pipelines/{id}:dealsCount | Retrieves the count of deals for a specific pipeline.
*PipelinesApi* | [**get_outcome_labels**](docs/PipelinesApi.md#get_outcome_labels) | **GET** /v2/pipelines/{id}/outcomes | Gets the outcome labels for a pipeline.
*PipelinesApi* | [**list**](docs/PipelinesApi.md#list) | **GET** /v2/pipelines | Lists entities based on the provided ListCommand.
*PipelinesApi* | [**list_stages**](docs/PipelinesApi.md#list_stages) | **GET** /v2/pipelines/{id}/stages | Retrieves a list of stages for a specific pipeline.
*PipelinesApi* | [**list_summaries**](docs/PipelinesApi.md#list_summaries) | **GET** /v2/pipelines/summaries | Retrieves a list of pipeline summaries.
*PipelinesApi* | [**set_outcome_labels**](docs/PipelinesApi.md#set_outcome_labels) | **PATCH** /v2/pipelines/{id}/outcomes | Sets the outcome labels for a pipeline.
*PipelinesApi* | [**update**](docs/PipelinesApi.md#update) | **PATCH** /v2/pipelines/{id} | Updates an existing entity.
*ProductInterestBundlesApi* | [**add_product_interest_using_post**](docs/ProductInterestBundlesApi.md#add_product_interest_using_post) | **POST** /v2/productInterestBundles/{id}/interests | Create a Product Interest in an existing Bundle
*ProductInterestBundlesApi* | [**create_product_interest_bundle_using_post**](docs/ProductInterestBundlesApi.md#create_product_interest_bundle_using_post) | **POST** /v2/productInterestBundles | Create a Product Interest Bundle
*ProductInterestBundlesApi* | [**delete_product_interest_bundle_using_delete**](docs/ProductInterestBundlesApi.md#delete_product_interest_bundle_using_delete) | **DELETE** /v2/productInterestBundles/{id} | Delete a Product Interest Bundle
*ProductInterestBundlesApi* | [**get_product_interest_bundle_using_get**](docs/ProductInterestBundlesApi.md#get_product_interest_bundle_using_get) | **GET** /v2/productInterestBundles/{id} | Get a Product Interest Bundle
*ProductInterestBundlesApi* | [**list_product_interest_bundles_using_get**](docs/ProductInterestBundlesApi.md#list_product_interest_bundles_using_get) | **GET** /v2/productInterestBundles | List Product Interest Bundles
*ProductInterestBundlesApi* | [**remove_product_interest_using_delete**](docs/ProductInterestBundlesApi.md#remove_product_interest_using_delete) | **DELETE** /v2/productInterestBundles/{id}/interests/{interest_id} | Delete a Product Interest from an existing Bundle
*ProductInterestBundlesApi* | [**update_product_interest_bundle_using_patch**](docs/ProductInterestBundlesApi.md#update_product_interest_bundle_using_patch) | **PATCH** /v2/productInterestBundles/{id} | Update a Product Interest Bundle
*ProductInterestBundlesApi* | [**update_product_interest_using_patch**](docs/ProductInterestBundlesApi.md#update_product_interest_using_patch) | **PATCH** /v2/productInterestBundles/{id}/interests/{interest_id} | Update a Product Interest in an existing Bundle
*ReportingApi* | [**list_reports_using_get**](docs/ReportingApi.md#list_reports_using_get) | **GET** /v2/reporting/reports | List Reports
*ReportingApi* | [**retrieve_report_using_get**](docs/ReportingApi.md#retrieve_report_using_get) | **GET** /v2/reporting/reports/{report_id} | Retrieve Report
*ReportingApi* | [**run_report_using_post**](docs/ReportingApi.md#run_report_using_post) | **POST** /v2/reporting/reports/{report_id}:run | Run a Report
*SalesApi* | [**set_merchant_gateway_as_default_using_post**](docs/SalesApi.md#set_merchant_gateway_as_default_using_post) | **POST** /v2/sales/merchants/{id}:setDefault | Set default Merchant Account
*SettingsApi* | [**get_application_configurations_using_get**](docs/SettingsApi.md#get_application_configurations_using_get) | **GET** /v2/settings/applications:getConfiguration | Get Application Configuration
*SettingsApi* | [**get_contact_option_types_using_get1**](docs/SettingsApi.md#get_contact_option_types_using_get1) | **GET** /v2/settings/contactOptionTypes | Get Contact Option types
*SettingsApi* | [**is_application_enabled_using_get**](docs/SettingsApi.md#is_application_enabled_using_get) | **GET** /v2/settings/applications:isEnabled | Get Application Status
*StagesApi* | [**count_deals_in_stage**](docs/StagesApi.md#count_deals_in_stage) | **GET** /v2/stages/{id}/dealCount | Counts the number of deals in a specific stage.
*StagesApi* | [**create1**](docs/StagesApi.md#create1) | **POST** /v2/stages | Creates a new entity.
*StagesApi* | [**delete1**](docs/StagesApi.md#delete1) | **DELETE** /v2/stages/{id} | Deletes a stage by its identifier for a given tenant.
*StagesApi* | [**get1**](docs/StagesApi.md#get1) | **GET** /v2/stages/{id} | Retrieves an entity by its identifier.
*StagesApi* | [**list1**](docs/StagesApi.md#list1) | **GET** /v2/stages | Lists entities based on the provided ListCommand.
*StagesApi* | [**list_stage_deals**](docs/StagesApi.md#list_stage_deals) | **GET** /v2/stages/{id}/deals | Retrieves a list of deals for a specific stage.
*StagesApi* | [**update1**](docs/StagesApi.md#update1) | **PATCH** /v2/stages/{id} | Updates an existing entity.
*SubscriptionsApi* | [**create_subscription_custom_field_using_post**](docs/SubscriptionsApi.md#create_subscription_custom_field_using_post) | **POST** /v2/subscriptions/model/customFields | Create a Subscription Custom Field
*SubscriptionsApi* | [**create_subscription_v2_using_post**](docs/SubscriptionsApi.md#create_subscription_v2_using_post) | **POST** /v2/subscriptions | Create Subscription
*SubscriptionsApi* | [**delete_subscription_custom_field_using_delete**](docs/SubscriptionsApi.md#delete_subscription_custom_field_using_delete) | **DELETE** /v2/subscriptions/model/customFields/{custom_field_id} | Delete a Subscription Custom Field
*SubscriptionsApi* | [**retrieve_subscription_custom_field_model_using_get**](docs/SubscriptionsApi.md#retrieve_subscription_custom_field_model_using_get) | **GET** /v2/subscriptions/model | Retrieve Subscription Custom Field Model
*SubscriptionsApi* | [**update_subscription_custom_field_using_patch**](docs/SubscriptionsApi.md#update_subscription_custom_field_using_patch) | **PATCH** /v2/subscriptions/model/customFields/{custom_field_id} | Update a Subscription Custom Field
*TagsApi* | [**apply_tags_using_post**](docs/TagsApi.md#apply_tags_using_post) | **POST** /v2/tags/{tag_id}/contacts:applyTags | Apply Tag
*TagsApi* | [**create_tag_category_using_post1**](docs/TagsApi.md#create_tag_category_using_post1) | **POST** /v2/tags/categories | Create Tag Category
*TagsApi* | [**create_tag_using_post1**](docs/TagsApi.md#create_tag_using_post1) | **POST** /v2/tags | Create Tag
*TagsApi* | [**delete_tag_category_using_delete**](docs/TagsApi.md#delete_tag_category_using_delete) | **DELETE** /v2/tags/categories/{tag_category_id} | Delete Tag Category
*TagsApi* | [**delete_tag_using_delete**](docs/TagsApi.md#delete_tag_using_delete) | **DELETE** /v2/tags/{tag_id} | Delete Tag
*TagsApi* | [**get_category_using_get**](docs/TagsApi.md#get_category_using_get) | **GET** /v2/tags/categories/{tag_category_id} | Retrieve a Tag Category
*TagsApi* | [**get_tag_using_get1**](docs/TagsApi.md#get_tag_using_get1) | **GET** /v2/tags/{tag_id} | Retrieve a Tag
*TagsApi* | [**list_companies_for_tag_id_using_get1**](docs/TagsApi.md#list_companies_for_tag_id_using_get1) | **GET** /v2/tags/{tag_id}/companies | List Tagged Companies
*TagsApi* | [**list_contacts_with_tag_id_using_get**](docs/TagsApi.md#list_contacts_with_tag_id_using_get) | **GET** /v2/tags/{tag_id}/contacts | List Tagged Contacts
*TagsApi* | [**list_tag_categories_using_get**](docs/TagsApi.md#list_tag_categories_using_get) | **GET** /v2/tags/categories | List Tag Categories
*TagsApi* | [**list_tags_using_get1**](docs/TagsApi.md#list_tags_using_get1) | **GET** /v2/tags | List Tags
*TagsApi* | [**remove_tags_using_post**](docs/TagsApi.md#remove_tags_using_post) | **POST** /v2/tags/{tag_id}/contacts:removeTags | Remove Tags
*TagsApi* | [**update_tag_category_using_patch**](docs/TagsApi.md#update_tag_category_using_patch) | **PATCH** /v2/tags/categories/{tag_category_id} | Update a Tag Category
*TagsApi* | [**update_tag_using_patch**](docs/TagsApi.md#update_tag_using_patch) | **PATCH** /v2/tags/{tag_id} | Update a Tag
*TaskApi* | [**create_task_custom_field_using_post1**](docs/TaskApi.md#create_task_custom_field_using_post1) | **POST** /v2/tasks/model/customFields | Create a Custom Field
*TaskApi* | [**create_task_using_post1**](docs/TaskApi.md#create_task_using_post1) | **POST** /v2/tasks | Create a Task
*TaskApi* | [**delete_task_custom_field_using_delete**](docs/TaskApi.md#delete_task_custom_field_using_delete) | **DELETE** /v2/tasks/model/customFields/{custom_field_id} | Delete a Custom Field
*TaskApi* | [**delete_task_using_delete1**](docs/TaskApi.md#delete_task_using_delete1) | **DELETE** /v2/tasks/{task_id} | Delete a Task
*TaskApi* | [**get_task_using_get1**](docs/TaskApi.md#get_task_using_get1) | **GET** /v2/tasks/{task_id} | Retrieve a Task
*TaskApi* | [**list_tasks_using_get1**](docs/TaskApi.md#list_tasks_using_get1) | **GET** /v2/tasks | List Tasks
*TaskApi* | [**retrieve_task_model_using_get1**](docs/TaskApi.md#retrieve_task_model_using_get1) | **GET** /v2/tasks/model | Retrieve Task Model
*TaskApi* | [**update_task_custom_field_using_patch**](docs/TaskApi.md#update_task_custom_field_using_patch) | **PATCH** /v2/tasks/model/customFields/{custom_field_id} | Update a Task&#39;s Custom Field
*TaskApi* | [**update_task_using_patch**](docs/TaskApi.md#update_task_using_patch) | **PATCH** /v2/tasks/{task_id} | Update a Task
*UsersApi* | [**list_paginated_users_using_get**](docs/UsersApi.md#list_paginated_users_using_get) | **GET** /v2/users | List Users


## Documentation For Models

 - [AddContactsToSequenceRequest](docs/AddContactsToSequenceRequest.md)
 - [AddContactsToSequenceResponse](docs/AddContactsToSequenceResponse.md)
 - [AddProductInterestRequest](docs/AddProductInterestRequest.md)
 - [AddToAutomationSequenceRequest](docs/AddToAutomationSequenceRequest.md)
 - [AddToAutomationSequenceResponse](docs/AddToAutomationSequenceResponse.md)
 - [Address](docs/Address.md)
 - [AddressInformation](docs/AddressInformation.md)
 - [AffiliateAddToProgramRequest](docs/AffiliateAddToProgramRequest.md)
 - [AffiliateCommission](docs/AffiliateCommission.md)
 - [AffiliateCommissionEarned](docs/AffiliateCommissionEarned.md)
 - [AffiliateCommissionProgramResponse](docs/AffiliateCommissionProgramResponse.md)
 - [AffiliateLink](docs/AffiliateLink.md)
 - [AffiliateProgramV2](docs/AffiliateProgramV2.md)
 - [AffiliateRemoveFromProgramRequest](docs/AffiliateRemoveFromProgramRequest.md)
 - [AffiliateSummaryRecord](docs/AffiliateSummaryRecord.md)
 - [ApplicationCompany](docs/ApplicationCompany.md)
 - [ApplicationConfigurationModuleAffiliate](docs/ApplicationConfigurationModuleAffiliate.md)
 - [ApplicationConfigurationModuleAffiliateCommission](docs/ApplicationConfigurationModuleAffiliateCommission.md)
 - [ApplicationConfigurationModuleApplication](docs/ApplicationConfigurationModuleApplication.md)
 - [ApplicationConfigurationModuleAppointment](docs/ApplicationConfigurationModuleAppointment.md)
 - [ApplicationConfigurationModuleContact](docs/ApplicationConfigurationModuleContact.md)
 - [ApplicationConfigurationModuleContactAddressLabels](docs/ApplicationConfigurationModuleContactAddressLabels.md)
 - [ApplicationConfigurationModuleEcommerce](docs/ApplicationConfigurationModuleEcommerce.md)
 - [ApplicationConfigurationModuleEmail](docs/ApplicationConfigurationModuleEmail.md)
 - [ApplicationConfigurationModuleForms](docs/ApplicationConfigurationModuleForms.md)
 - [ApplicationConfigurationModuleFulfillment](docs/ApplicationConfigurationModuleFulfillment.md)
 - [ApplicationConfigurationModuleInvoice](docs/ApplicationConfigurationModuleInvoice.md)
 - [ApplicationConfigurationModuleNote](docs/ApplicationConfigurationModuleNote.md)
 - [ApplicationConfigurationModuleOpportunity](docs/ApplicationConfigurationModuleOpportunity.md)
 - [ApplicationConfigurationModuleOpportunityStates](docs/ApplicationConfigurationModuleOpportunityStates.md)
 - [ApplicationConfigurationModuleOpportunityStatesActive](docs/ApplicationConfigurationModuleOpportunityStatesActive.md)
 - [ApplicationConfigurationModuleOpportunityStatesLoss](docs/ApplicationConfigurationModuleOpportunityStatesLoss.md)
 - [ApplicationConfigurationModuleOpportunityStatesWin](docs/ApplicationConfigurationModuleOpportunityStatesWin.md)
 - [ApplicationConfigurationModuleTask](docs/ApplicationConfigurationModuleTask.md)
 - [ApplicationConfigurationModuleTemplate](docs/ApplicationConfigurationModuleTemplate.md)
 - [ApplicationFeaturesEnabled](docs/ApplicationFeaturesEnabled.md)
 - [ApplyRemoveTagRequest](docs/ApplyRemoveTagRequest.md)
 - [ApplyTagsResponse](docs/ApplyTagsResponse.md)
 - [AssignAutomationCategoryRequest](docs/AssignAutomationCategoryRequest.md)
 - [AssignProductCategoriesRequest](docs/AssignProductCategoriesRequest.md)
 - [AssignProductsRequest](docs/AssignProductsRequest.md)
 - [Automation](docs/Automation.md)
 - [AutomationCategory](docs/AutomationCategory.md)
 - [AutomationLockStatus](docs/AutomationLockStatus.md)
 - [BaseListResponseDeal](docs/BaseListResponseDeal.md)
 - [BaseListResponseDealNote](docs/BaseListResponseDealNote.md)
 - [BaseListResponsePipeline](docs/BaseListResponsePipeline.md)
 - [BaseListResponsePipelineSummary](docs/BaseListResponsePipelineSummary.md)
 - [BaseListResponseStage](docs/BaseListResponseStage.md)
 - [BasicCompany](docs/BasicCompany.md)
 - [BasicContact](docs/BasicContact.md)
 - [BasicUser](docs/BasicUser.md)
 - [BulkCreateDealNoteRequest](docs/BulkCreateDealNoteRequest.md)
 - [BulkCreateDealNoteResponse](docs/BulkCreateDealNoteResponse.md)
 - [BulkCreateDealNotesRequest](docs/BulkCreateDealNotesRequest.md)
 - [BulkCreateDealNotesResponse](docs/BulkCreateDealNotesResponse.md)
 - [BusinessProfileAddressRequest](docs/BusinessProfileAddressRequest.md)
 - [BusinessProfileAddressResponse](docs/BusinessProfileAddressResponse.md)
 - [Campaign](docs/Campaign.md)
 - [CancelSubscriptionsRequest](docs/CancelSubscriptionsRequest.md)
 - [CardInfo](docs/CardInfo.md)
 - [CategoryDiscount](docs/CategoryDiscount.md)
 - [CategoryReference](docs/CategoryReference.md)
 - [CheckListItemDetails](docs/CheckListItemDetails.md)
 - [ChecklistItem](docs/ChecklistItem.md)
 - [Company](docs/Company.md)
 - [Contact](docs/Contact.md)
 - [ContactLink](docs/ContactLink.md)
 - [ContactLinkType](docs/ContactLinkType.md)
 - [ContactUtmResponse](docs/ContactUtmResponse.md)
 - [Country](docs/Country.md)
 - [CreateAffiliateRequest](docs/CreateAffiliateRequest.md)
 - [CreateAutomationCategoryRequest](docs/CreateAutomationCategoryRequest.md)
 - [CreateCategoryDiscountRequest](docs/CreateCategoryDiscountRequest.md)
 - [CreateCommissionProgramRequest](docs/CreateCommissionProgramRequest.md)
 - [CreateCompanyRequest](docs/CreateCompanyRequest.md)
 - [CreateContactLinkTypeRequest](docs/CreateContactLinkTypeRequest.md)
 - [CreateContactUtmPropertiesRequest](docs/CreateContactUtmPropertiesRequest.md)
 - [CreateCustomFieldOptionRequest](docs/CreateCustomFieldOptionRequest.md)
 - [CreateCustomFieldRequest](docs/CreateCustomFieldRequest.md)
 - [CreateCustomFieldResponse](docs/CreateCustomFieldResponse.md)
 - [CreateDealNoteRequest](docs/CreateDealNoteRequest.md)
 - [CreateDealRequest](docs/CreateDealRequest.md)
 - [CreateDefaultCommissionProgramRequest](docs/CreateDefaultCommissionProgramRequest.md)
 - [CreateEmailSentRequest](docs/CreateEmailSentRequest.md)
 - [CreateEmailsSentRequest](docs/CreateEmailsSentRequest.md)
 - [CreateFreeTrialDiscountRequest](docs/CreateFreeTrialDiscountRequest.md)
 - [CreateFunnelIntegrationRequest](docs/CreateFunnelIntegrationRequest.md)
 - [CreateFunnelIntegrationTriggerEvents](docs/CreateFunnelIntegrationTriggerEvents.md)
 - [CreateLeadSourceExpenseRequest](docs/CreateLeadSourceExpenseRequest.md)
 - [CreateLeadSourceRecurringExpenseRequest](docs/CreateLeadSourceRecurringExpenseRequest.md)
 - [CreateLeadSourceRequest](docs/CreateLeadSourceRequest.md)
 - [CreateNoteRequest](docs/CreateNoteRequest.md)
 - [CreateOpportunityRequest](docs/CreateOpportunityRequest.md)
 - [CreateOpportunityStageChecklistItem](docs/CreateOpportunityStageChecklistItem.md)
 - [CreateOpportunityStageRequest](docs/CreateOpportunityStageRequest.md)
 - [CreateOrUpdateAffiliateLinkRequest](docs/CreateOrUpdateAffiliateLinkRequest.md)
 - [CreateOrderTotalDiscountRequest](docs/CreateOrderTotalDiscountRequest.md)
 - [CreatePaymentMethodConfigRequest](docs/CreatePaymentMethodConfigRequest.md)
 - [CreatePaymentRequest](docs/CreatePaymentRequest.md)
 - [CreatePipelineRequest](docs/CreatePipelineRequest.md)
 - [CreateProductCategoryRequest](docs/CreateProductCategoryRequest.md)
 - [CreateProductCommissionProgramRequest](docs/CreateProductCommissionProgramRequest.md)
 - [CreateProductDiscountRequest](docs/CreateProductDiscountRequest.md)
 - [CreateProductInterestBundleRequest](docs/CreateProductInterestBundleRequest.md)
 - [CreateProductRequest](docs/CreateProductRequest.md)
 - [CreateReferralRequest](docs/CreateReferralRequest.md)
 - [CreateRestOrderItemRequest](docs/CreateRestOrderItemRequest.md)
 - [CreateShippingDiscountRequest](docs/CreateShippingDiscountRequest.md)
 - [CreateStageRequest](docs/CreateStageRequest.md)
 - [CreateSubscriptionCommissionProgramRequest](docs/CreateSubscriptionCommissionProgramRequest.md)
 - [CreateSubscriptionPlanRequest](docs/CreateSubscriptionPlanRequest.md)
 - [CreateSubscriptionV2](docs/CreateSubscriptionV2.md)
 - [CreateTaskRequest](docs/CreateTaskRequest.md)
 - [CreateUpdateContactRequest](docs/CreateUpdateContactRequest.md)
 - [CreateUpdateLeadSourceCategoryRequest](docs/CreateUpdateLeadSourceCategoryRequest.md)
 - [CreateUpdateTagCategoryRequest](docs/CreateUpdateTagCategoryRequest.md)
 - [CreateUpdateTagRequest](docs/CreateUpdateTagRequest.md)
 - [CreateUpdateTaskRequest](docs/CreateUpdateTaskRequest.md)
 - [CreateUserRequestV2](docs/CreateUserRequestV2.md)
 - [CurrencyValue](docs/CurrencyValue.md)
 - [CustomField](docs/CustomField.md)
 - [CustomFieldMetaData](docs/CustomFieldMetaData.md)
 - [CustomFieldOption](docs/CustomFieldOption.md)
 - [CustomFieldValue](docs/CustomFieldValue.md)
 - [DateExpression](docs/DateExpression.md)
 - [DateExpressionResponse](docs/DateExpressionResponse.md)
 - [Deal](docs/Deal.md)
 - [DealContact](docs/DealContact.md)
 - [DealListResponse](docs/DealListResponse.md)
 - [DealNote](docs/DealNote.md)
 - [DealNoteListResponse](docs/DealNoteListResponse.md)
 - [DealStatus](docs/DealStatus.md)
 - [DefaultCommission](docs/DefaultCommission.md)
 - [DeleteEmailsRequest](docs/DeleteEmailsRequest.md)
 - [DeleteEmailsResponse](docs/DeleteEmailsResponse.md)
 - [DeleteFunnelIntegrationRequest](docs/DeleteFunnelIntegrationRequest.md)
 - [DeleteProgramCommissionRequest](docs/DeleteProgramCommissionRequest.md)
 - [DeleteSubscriptionPlanCommissionRequest](docs/DeleteSubscriptionPlanCommissionRequest.md)
 - [Discount](docs/Discount.md)
 - [DiscountCriteria](docs/DiscountCriteria.md)
 - [DisplayForm](docs/DisplayForm.md)
 - [DisplayGroup](docs/DisplayGroup.md)
 - [DisplayProperty](docs/DisplayProperty.md)
 - [DisplayPropertySource](docs/DisplayPropertySource.md)
 - [EmailAddress](docs/EmailAddress.md)
 - [EmailAddressRequest](docs/EmailAddressRequest.md)
 - [EmailAddressStatus](docs/EmailAddressStatus.md)
 - [EmailSendRequest](docs/EmailSendRequest.md)
 - [EmailSendRequestAttachment](docs/EmailSendRequestAttachment.md)
 - [EmailSendTemplateRequest](docs/EmailSendTemplateRequest.md)
 - [EmailSentCreateError](docs/EmailSentCreateError.md)
 - [EmailSentWithContent](docs/EmailSentWithContent.md)
 - [EmailTemplate](docs/EmailTemplate.md)
 - [EmailsSentList](docs/EmailsSentList.md)
 - [Error](docs/Error.md)
 - [ErrorDetails](docs/ErrorDetails.md)
 - [FaxNumber](docs/FaxNumber.md)
 - [File](docs/File.md)
 - [FileMetadata](docs/FileMetadata.md)
 - [FileOperationRequest](docs/FileOperationRequest.md)
 - [FreeTrialDiscount](docs/FreeTrialDiscount.md)
 - [FunnelIntegrationAction](docs/FunnelIntegrationAction.md)
 - [FunnelIntegrationHttpRequest](docs/FunnelIntegrationHttpRequest.md)
 - [FunnelIntegrationSchemaField](docs/FunnelIntegrationSchemaField.md)
 - [FunnelIntegrationTriggerEventDTO](docs/FunnelIntegrationTriggerEventDTO.md)
 - [FunnelIntegrationTriggerResultDTO](docs/FunnelIntegrationTriggerResultDTO.md)
 - [GetApplicationEnabledStatusResponse](docs/GetApplicationEnabledStatusResponse.md)
 - [GetBusinessProfileResponse](docs/GetBusinessProfileResponse.md)
 - [GetContactOptionTypesResponse](docs/GetContactOptionTypesResponse.md)
 - [GetNoteResponse](docs/GetNoteResponse.md)
 - [GetSettingsResponse](docs/GetSettingsResponse.md)
 - [GetTagCategoryResponse](docs/GetTagCategoryResponse.md)
 - [GetUserInfoResponse](docs/GetUserInfoResponse.md)
 - [Goal](docs/Goal.md)
 - [HistoricalCounts](docs/HistoricalCounts.md)
 - [InvoiceFile](docs/InvoiceFile.md)
 - [InvoiceOrderPayment](docs/InvoiceOrderPayment.md)
 - [Item](docs/Item.md)
 - [LandingPage](docs/LandingPage.md)
 - [LeadScore](docs/LeadScore.md)
 - [LeadSource](docs/LeadSource.md)
 - [LeadSourceCategory](docs/LeadSourceCategory.md)
 - [LeadSourceExpense](docs/LeadSourceExpense.md)
 - [LeadSourceRecurringExpense](docs/LeadSourceRecurringExpense.md)
 - [LeadSourceRecurringExpenseUpdateRequest](docs/LeadSourceRecurringExpenseUpdateRequest.md)
 - [Link](docs/Link.md)
 - [LinkContactsRequest](docs/LinkContactsRequest.md)
 - [ListAffiliateCommissionProgramsResponse](docs/ListAffiliateCommissionProgramsResponse.md)
 - [ListAffiliateCommissionsResponse](docs/ListAffiliateCommissionsResponse.md)
 - [ListAffiliateLinksResponse](docs/ListAffiliateLinksResponse.md)
 - [ListAffiliateSummariesResponse](docs/ListAffiliateSummariesResponse.md)
 - [ListAutomationCategoryResponse](docs/ListAutomationCategoryResponse.md)
 - [ListAutomationIdsResponse](docs/ListAutomationIdsResponse.md)
 - [ListAutomationResponse](docs/ListAutomationResponse.md)
 - [ListBasicContactResponse](docs/ListBasicContactResponse.md)
 - [ListCampaignsResponse](docs/ListCampaignsResponse.md)
 - [ListCategoryDiscountsResponse](docs/ListCategoryDiscountsResponse.md)
 - [ListCompaniesResponse](docs/ListCompaniesResponse.md)
 - [ListContactLinkTypesResponse](docs/ListContactLinkTypesResponse.md)
 - [ListContactLinksResponse](docs/ListContactLinksResponse.md)
 - [ListContactsResponse](docs/ListContactsResponse.md)
 - [ListCountriesResponse](docs/ListCountriesResponse.md)
 - [ListFilesResponse](docs/ListFilesResponse.md)
 - [ListFreeTrialDiscountsResponse](docs/ListFreeTrialDiscountsResponse.md)
 - [ListLandingPagesResponse](docs/ListLandingPagesResponse.md)
 - [ListLeadSourceCategoriesResponse](docs/ListLeadSourceCategoriesResponse.md)
 - [ListLeadSourceExpensesResponse](docs/ListLeadSourceExpensesResponse.md)
 - [ListLeadSourceRecurringExpensesResponse](docs/ListLeadSourceRecurringExpensesResponse.md)
 - [ListLeadSourcesResponse](docs/ListLeadSourcesResponse.md)
 - [ListNoteTemplateResponse](docs/ListNoteTemplateResponse.md)
 - [ListNotesResponse](docs/ListNotesResponse.md)
 - [ListOpportunitiesResponse](docs/ListOpportunitiesResponse.md)
 - [ListOpportunityStagesResponse](docs/ListOpportunityStagesResponse.md)
 - [ListOrderPaymentsResponse](docs/ListOrderPaymentsResponse.md)
 - [ListOrderTotalDiscountsResponse](docs/ListOrderTotalDiscountsResponse.md)
 - [ListOrders](docs/ListOrders.md)
 - [ListPaymentMethodsResponse](docs/ListPaymentMethodsResponse.md)
 - [ListProductCategoriesResponse](docs/ListProductCategoriesResponse.md)
 - [ListProductDiscountsResponse](docs/ListProductDiscountsResponse.md)
 - [ListProductInterestBundleResponse](docs/ListProductInterestBundleResponse.md)
 - [ListProductsResponse](docs/ListProductsResponse.md)
 - [ListProvincesResponse](docs/ListProvincesResponse.md)
 - [ListReportsResponse](docs/ListReportsResponse.md)
 - [ListRestMerchantAccountResponse](docs/ListRestMerchantAccountResponse.md)
 - [ListRestMerchantResponse](docs/ListRestMerchantResponse.md)
 - [ListRestShippingMethodsResponse](docs/ListRestShippingMethodsResponse.md)
 - [ListShippingDiscountsResponse](docs/ListShippingDiscountsResponse.md)
 - [ListSubscriptionPlansResponse](docs/ListSubscriptionPlansResponse.md)
 - [ListSubscriptionsResponse](docs/ListSubscriptionsResponse.md)
 - [ListTagCategoriesResponse](docs/ListTagCategoriesResponse.md)
 - [ListTaggedCompaniesResponse](docs/ListTaggedCompaniesResponse.md)
 - [ListTaggedContactsResponse](docs/ListTaggedContactsResponse.md)
 - [ListTagsResponse](docs/ListTagsResponse.md)
 - [ListTasksResponse](docs/ListTasksResponse.md)
 - [ListTransactionsResponse](docs/ListTransactionsResponse.md)
 - [ListUsersPaginatedResponse](docs/ListUsersPaginatedResponse.md)
 - [LogicalDate](docs/LogicalDate.md)
 - [Money](docs/Money.md)
 - [Note](docs/Note.md)
 - [NoteTemplate](docs/NoteTemplate.md)
 - [ObjectModel](docs/ObjectModel.md)
 - [OpportunityContact](docs/OpportunityContact.md)
 - [OpportunityStage](docs/OpportunityStage.md)
 - [OrderItemProduct](docs/OrderItemProduct.md)
 - [OrderItemTax](docs/OrderItemTax.md)
 - [OrderTotalDiscount](docs/OrderTotalDiscount.md)
 - [Origin](docs/Origin.md)
 - [OriginRequest](docs/OriginRequest.md)
 - [Owner](docs/Owner.md)
 - [PatchAutomationCategoryRequest](docs/PatchAutomationCategoryRequest.md)
 - [PaymentMethod](docs/PaymentMethod.md)
 - [PaymentMethodConfig](docs/PaymentMethodConfig.md)
 - [PaymentPlan](docs/PaymentPlan.md)
 - [PaymentResult](docs/PaymentResult.md)
 - [PhoneNumber](docs/PhoneNumber.md)
 - [Pipeline](docs/Pipeline.md)
 - [PipelineCustomField](docs/PipelineCustomField.md)
 - [PipelineCustomFieldArrayDisplayOptions](docs/PipelineCustomFieldArrayDisplayOptions.md)
 - [PipelineCustomFieldArrayPropertyType](docs/PipelineCustomFieldArrayPropertyType.md)
 - [PipelineCustomFieldBooleanDisplayOptions](docs/PipelineCustomFieldBooleanDisplayOptions.md)
 - [PipelineCustomFieldBooleanDisplayType](docs/PipelineCustomFieldBooleanDisplayType.md)
 - [PipelineCustomFieldCardDisplayOptions](docs/PipelineCustomFieldCardDisplayOptions.md)
 - [PipelineCustomFieldCardProperty](docs/PipelineCustomFieldCardProperty.md)
 - [PipelineCustomFieldDateTimeOptions](docs/PipelineCustomFieldDateTimeOptions.md)
 - [PipelineCustomFieldDisplayOptions](docs/PipelineCustomFieldDisplayOptions.md)
 - [PipelineCustomFieldDisplayOptionsType](docs/PipelineCustomFieldDisplayOptionsType.md)
 - [PipelineCustomFieldDisplayStyle](docs/PipelineCustomFieldDisplayStyle.md)
 - [PipelineCustomFieldDurationDisplayOptions](docs/PipelineCustomFieldDurationDisplayOptions.md)
 - [PipelineCustomFieldDurationOptionsDurationUnit](docs/PipelineCustomFieldDurationOptionsDurationUnit.md)
 - [PipelineCustomFieldEmptyStateContent](docs/PipelineCustomFieldEmptyStateContent.md)
 - [PipelineCustomFieldModelPropertyTypeDiscriminator](docs/PipelineCustomFieldModelPropertyTypeDiscriminator.md)
 - [PipelineCustomFieldOption](docs/PipelineCustomFieldOption.md)
 - [PipelineCustomFieldOptionDisplayType](docs/PipelineCustomFieldOptionDisplayType.md)
 - [PipelineCustomFieldOptionGroup](docs/PipelineCustomFieldOptionGroup.md)
 - [PipelineCustomFieldOptions](docs/PipelineCustomFieldOptions.md)
 - [PipelineCustomFieldPrimitiveType](docs/PipelineCustomFieldPrimitiveType.md)
 - [PipelineCustomFieldPropertyValidator](docs/PipelineCustomFieldPropertyValidator.md)
 - [PipelineCustomFieldRefDisplayOptions](docs/PipelineCustomFieldRefDisplayOptions.md)
 - [PipelineCustomFieldRefDisplayType](docs/PipelineCustomFieldRefDisplayType.md)
 - [PipelineCustomFieldRefPropertyType](docs/PipelineCustomFieldRefPropertyType.md)
 - [PipelineCustomFieldRefType](docs/PipelineCustomFieldRefType.md)
 - [PipelineCustomFieldSizeValidationType](docs/PipelineCustomFieldSizeValidationType.md)
 - [PipelineCustomFieldSizeValidator](docs/PipelineCustomFieldSizeValidator.md)
 - [PipelineCustomFieldType](docs/PipelineCustomFieldType.md)
 - [PipelineCustomFields](docs/PipelineCustomFields.md)
 - [PipelineListResponse](docs/PipelineListResponse.md)
 - [PipelineOutcomeLabel](docs/PipelineOutcomeLabel.md)
 - [PipelineOutcomeLabelListResponse](docs/PipelineOutcomeLabelListResponse.md)
 - [PipelineStageListResponse](docs/PipelineStageListResponse.md)
 - [PipelineSummariesListResponse](docs/PipelineSummariesListResponse.md)
 - [PipelineSummary](docs/PipelineSummary.md)
 - [ProductCategory](docs/ProductCategory.md)
 - [ProductCommission](docs/ProductCommission.md)
 - [ProductCommissionProgram](docs/ProductCommissionProgram.md)
 - [ProductDiscount](docs/ProductDiscount.md)
 - [ProductFixedOption](docs/ProductFixedOption.md)
 - [ProductInterest](docs/ProductInterest.md)
 - [ProductInterestBundle](docs/ProductInterestBundle.md)
 - [ProductInventory](docs/ProductInventory.md)
 - [ProductOptions](docs/ProductOptions.md)
 - [ProductVariableSetting](docs/ProductVariableSetting.md)
 - [Provinces](docs/Provinces.md)
 - [Referral](docs/Referral.md)
 - [RemoveContactsFromSequenceRequest](docs/RemoveContactsFromSequenceRequest.md)
 - [RemoveContactsFromSequenceResponse](docs/RemoveContactsFromSequenceResponse.md)
 - [Report](docs/Report.md)
 - [ReportEntryRecord](docs/ReportEntryRecord.md)
 - [ReportEntryValue](docs/ReportEntryValue.md)
 - [ReportExecutionResult](docs/ReportExecutionResult.md)
 - [Resource](docs/Resource.md)
 - [RestAffiliate](docs/RestAffiliate.md)
 - [RestApplyCommissionRequest](docs/RestApplyCommissionRequest.md)
 - [RestCreateOrderRequest](docs/RestCreateOrderRequest.md)
 - [RestEmailAddress](docs/RestEmailAddress.md)
 - [RestOpportunityStage](docs/RestOpportunityStage.md)
 - [RestProductOption](docs/RestProductOption.md)
 - [RestProductOptionValue](docs/RestProductOptionValue.md)
 - [RestSubscriptionPlan](docs/RestSubscriptionPlan.md)
 - [RestSubscriptionV2](docs/RestSubscriptionV2.md)
 - [RestV2Opportunity](docs/RestV2Opportunity.md)
 - [RestV2Order](docs/RestV2Order.md)
 - [RestV2OrderItem](docs/RestV2OrderItem.md)
 - [RestV2Product](docs/RestV2Product.md)
 - [RestV2Subscription](docs/RestV2Subscription.md)
 - [RestV2User](docs/RestV2User.md)
 - [SaveAutomationCategoryRequest](docs/SaveAutomationCategoryRequest.md)
 - [Sequence](docs/Sequence.md)
 - [SequencePath](docs/SequencePath.md)
 - [SetDefaultCommissionProgramResponse](docs/SetDefaultCommissionProgramResponse.md)
 - [ShippingDiscount](docs/ShippingDiscount.md)
 - [ShippingInformation](docs/ShippingInformation.md)
 - [ShippingMethod](docs/ShippingMethod.md)
 - [SocialAccount](docs/SocialAccount.md)
 - [StackTraceElement](docs/StackTraceElement.md)
 - [Stage](docs/Stage.md)
 - [StageDealListResponse](docs/StageDealListResponse.md)
 - [StageDetails](docs/StageDetails.md)
 - [StageListResponse](docs/StageListResponse.md)
 - [SubscriptionCommission](docs/SubscriptionCommission.md)
 - [SubscriptionCommissionProgram](docs/SubscriptionCommissionProgram.md)
 - [SubscriptionPlan](docs/SubscriptionPlan.md)
 - [Tag](docs/Tag.md)
 - [TaggedCompany](docs/TaggedCompany.md)
 - [Task](docs/Task.md)
 - [Throwable](docs/Throwable.md)
 - [Transaction](docs/Transaction.md)
 - [URI](docs/URI.md)
 - [URL](docs/URL.md)
 - [UpdateAffiliateRequest](docs/UpdateAffiliateRequest.md)
 - [UpdateAutomationCategoryRequest](docs/UpdateAutomationCategoryRequest.md)
 - [UpdateBusinessProfileRequest](docs/UpdateBusinessProfileRequest.md)
 - [UpdateCategoryDiscountRequest](docs/UpdateCategoryDiscountRequest.md)
 - [UpdateCommissionProgramRequest](docs/UpdateCommissionProgramRequest.md)
 - [UpdateCompanyRequest](docs/UpdateCompanyRequest.md)
 - [UpdateCustomFieldMetaDataRequest](docs/UpdateCustomFieldMetaDataRequest.md)
 - [UpdateCustomFieldRequest](docs/UpdateCustomFieldRequest.md)
 - [UpdateDealNoteRequest](docs/UpdateDealNoteRequest.md)
 - [UpdateDefaultCommissionProgramRequest](docs/UpdateDefaultCommissionProgramRequest.md)
 - [UpdateDisplayFormRequest](docs/UpdateDisplayFormRequest.md)
 - [UpdateDisplayGroupRequest](docs/UpdateDisplayGroupRequest.md)
 - [UpdateDisplayPropertyRequest](docs/UpdateDisplayPropertyRequest.md)
 - [UpdateEmailAddress](docs/UpdateEmailAddress.md)
 - [UpdateFreeTrialDiscountRequest](docs/UpdateFreeTrialDiscountRequest.md)
 - [UpdateLeadSourceExpenseRequest](docs/UpdateLeadSourceExpenseRequest.md)
 - [UpdateNoteRequest](docs/UpdateNoteRequest.md)
 - [UpdateNoteResponse](docs/UpdateNoteResponse.md)
 - [UpdateOpportunityRequestV2](docs/UpdateOpportunityRequestV2.md)
 - [UpdateOpportunityStageChecklistItem](docs/UpdateOpportunityStageChecklistItem.md)
 - [UpdateOpportunityStageRequest](docs/UpdateOpportunityStageRequest.md)
 - [UpdateOrderItemRequest](docs/UpdateOrderItemRequest.md)
 - [UpdateOrderRequest](docs/UpdateOrderRequest.md)
 - [UpdateOrderTotalDiscountRequest](docs/UpdateOrderTotalDiscountRequest.md)
 - [UpdateOutcomeLabelsRequest](docs/UpdateOutcomeLabelsRequest.md)
 - [UpdatePipelineRequest](docs/UpdatePipelineRequest.md)
 - [UpdateProductCategoryRequest](docs/UpdateProductCategoryRequest.md)
 - [UpdateProductCommissionProgramRequest](docs/UpdateProductCommissionProgramRequest.md)
 - [UpdateProductDiscountRequest](docs/UpdateProductDiscountRequest.md)
 - [UpdateProductInterestBundleRequest](docs/UpdateProductInterestBundleRequest.md)
 - [UpdateProductInterestRequest](docs/UpdateProductInterestRequest.md)
 - [UpdateProductInventoryRequest](docs/UpdateProductInventoryRequest.md)
 - [UpdateProductRequest](docs/UpdateProductRequest.md)
 - [UpdateShippingDiscountRequest](docs/UpdateShippingDiscountRequest.md)
 - [UpdateStageRequest](docs/UpdateStageRequest.md)
 - [UpdateSubscriptionCommissionProgramRequest](docs/UpdateSubscriptionCommissionProgramRequest.md)
 - [UpdateSubscriptionPlanRequest](docs/UpdateSubscriptionPlanRequest.md)
 - [UpdateSubscriptionRequest](docs/UpdateSubscriptionRequest.md)
 - [UpdateTagCategoryResponse](docs/UpdateTagCategoryResponse.md)
 - [UpdateTagResponse](docs/UpdateTagResponse.md)
 - [UpdateTaskResponse](docs/UpdateTaskResponse.md)
 - [UpdateUserRequest](docs/UpdateUserRequest.md)
 - [UpdatedPaymentPlan](docs/UpdatedPaymentPlan.md)
 - [User](docs/User.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://accounts.infusionsoft.com/app/oauth/authorize
- **Scopes**: N/A


## Author

api@keap.com

