# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.809589
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FileMetadata(BaseModel):
    """
    FileMetadata
    """ # noqa: E501
    category: Optional[StrictStr] = None
    contact_id: Optional[StrictStr] = None
    created_by_id: Optional[StrictStr] = None
    created_time: Optional[StrictStr] = None
    file_box_type: Optional[StrictStr] = None
    file_name: Optional[StrictStr] = None
    file_size: Optional[StrictInt] = None
    id: Optional[StrictStr] = None
    is_public: Optional[StrictBool] = None
    remote_file_key: Optional[StrictStr] = None
    updated_time: Optional[StrictStr] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["category", "contact_id", "created_by_id", "created_time", "file_box_type", "file_name", "file_size", "id", "is_public", "remote_file_key", "updated_time"]

    @field_validator('category')
    def category_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ATTACHMENTS', 'CART', 'DOCUMENTS', 'HIDDEN', 'INVOICE', 'LOGO', 'TICKETS', 'WEB_FORM', 'FUNNEL']):
            raise ValueError("must be one of enum values ('ATTACHMENTS', 'CART', 'DOCUMENTS', 'HIDDEN', 'INVOICE', 'LOGO', 'TICKETS', 'WEB_FORM', 'FUNNEL')")
        return value

    @field_validator('file_box_type')
    def file_box_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['APPLICATION', 'IMAGE', 'FAX', 'ATTACHMENT', 'TICKET', 'CONTACT', 'DIGITAL_PRODUCT', 'IMPORT', 'HIDDEN', 'WEB_FORM', 'STYLED_CART', 'RESAMPLED_IMAGE', 'TEMPLATE_THUMBNAIL', 'FUNNEL', 'LOGO_THUMBNAIL', 'UNLAYER', 'BRANDING_CENTER_LOGO']):
            raise ValueError("must be one of enum values ('APPLICATION', 'IMAGE', 'FAX', 'ATTACHMENT', 'TICKET', 'CONTACT', 'DIGITAL_PRODUCT', 'IMPORT', 'HIDDEN', 'WEB_FORM', 'STYLED_CART', 'RESAMPLED_IMAGE', 'TEMPLATE_THUMBNAIL', 'FUNNEL', 'LOGO_THUMBNAIL', 'UNLAYER', 'BRANDING_CENTER_LOGO')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FileMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FileMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "category": obj.get("category"),
            "contact_id": obj.get("contact_id"),
            "created_by_id": obj.get("created_by_id"),
            "created_time": obj.get("created_time"),
            "file_box_type": obj.get("file_box_type"),
            "file_name": obj.get("file_name"),
            "file_size": obj.get("file_size"),
            "id": obj.get("id"),
            "is_public": obj.get("is_public"),
            "remote_file_key": obj.get("remote_file_key"),
            "updated_time": obj.get("updated_time")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


