# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.809589
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from keap_core_v2_client.models.pipeline_custom_field_model_property_type_discriminator import PipelineCustomFieldModelPropertyTypeDiscriminator
from keap_core_v2_client.models.pipeline_custom_field_primitive_type import PipelineCustomFieldPrimitiveType
from keap_core_v2_client.models.pipeline_custom_field_ref_property_type import PipelineCustomFieldRefPropertyType
from typing import Optional, Set
from typing_extensions import Self

class PipelineCustomFieldType(BaseModel):
    """
    Class representing a custom field type.
    """ # noqa: E501
    primitive_type: PipelineCustomFieldPrimitiveType = Field(description="The base primitive type of the custom field. This field is required.")
    discriminator: PipelineCustomFieldModelPropertyTypeDiscriminator = Field(description="The discriminator for the model property type. This field is required.")
    array: Optional[PipelineCustomFieldArrayPropertyType] = Field(default=None, description="The array property type of the custom field. This field is optional.")
    ref: Optional[PipelineCustomFieldRefPropertyType] = Field(default=None, description="The reference property type of the custom field. This field is optional.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["primitive_type", "discriminator", "array", "ref"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PipelineCustomFieldType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of array
        if self.array:
            _dict['array'] = self.array.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ref
        if self.ref:
            _dict['ref'] = self.ref.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if array (nullable) is None
        # and model_fields_set contains the field
        if self.array is None and "array" in self.model_fields_set:
            _dict['array'] = None

        # set to None if ref (nullable) is None
        # and model_fields_set contains the field
        if self.ref is None and "ref" in self.model_fields_set:
            _dict['ref'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PipelineCustomFieldType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "primitive_type": obj.get("primitive_type"),
            "discriminator": obj.get("discriminator"),
            "array": PipelineCustomFieldArrayPropertyType.from_dict(obj["array"]) if obj.get("array") is not None else None,
            "ref": PipelineCustomFieldRefPropertyType.from_dict(obj["ref"]) if obj.get("ref") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

from keap_core_v2_client.models.pipeline_custom_field_array_property_type import PipelineCustomFieldArrayPropertyType
# TODO: Rewrite to not use raise_errors
PipelineCustomFieldType.model_rebuild(raise_errors=False)

